package com.nhnst.oc.sso.controller;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.core.TreeNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.nhnst.oc.sso.model.ReturnHeader;
import com.nhnst.oc.sso.model.ReturnModel;
import com.nhnst.oc.sso.utils.TokenUtil;

@RestController
public class CallbackApiController extends AbstractLoginController {
	private final String apiKey = "0718d0c278714a99b1a444405ef03778";

	/**
	 * Callback api sample
	 * 
	 * @param request
	 * @param response
	 * @param token
	 * @param timestamp
	 * @return ReturnModel
	 */
	@SuppressWarnings("unchecked")
	@RequestMapping(value = "/api/receive/ticket/info.nhn", method = RequestMethod.POST)
	public ReturnModel<Map<String, Object>> info(HttpServletRequest request, HttpServletResponse response, String token,
			Long timestamp) {
		Map<String, Object> result = new HashMap<String, Object>();
		try {
			String body = new String(IOUtils.toByteArray(request.getInputStream()));
			System.out.println(body);

			ObjectMapper mapper = new ObjectMapper();
			TreeNode treeNode = mapper.readTree(body);
			Map<String, Object> map = mapper.treeToValue(treeNode, Map.class);

			String localToken = TokenUtil.generateToken(apiKey, body, timestamp);

			System.out.println("Receive toke: " + token);
			if (StringUtils.equals(token, localToken)) {
				System.out.println("--------------------");
				System.out.println(map.get("tid"));
				System.out.println(map.get("status"));
				System.out.println(map.get("srcid"));
				System.out.println(map.get("content"));
				System.out.println(map.get("comment"));
				Map<String, Object> enduser = (Map<String, Object>)map.get("enduser");
				System.out.println(enduser.get("userid"));
				System.out.println(enduser.get("usercode"));
				System.out.println(enduser.get("username"));
				System.out.println(enduser.get("email"));
				System.out.println(enduser.get("phone"));
				System.out.println(enduser.get("memberno"));
				System.out.println("timestamp: " + timestamp);
				System.out.println("token" + token);
				System.out.println("--------------------");
			} else {
				result.put("message", "Invalid token");
				ReturnModel<Map<String, Object>> model = new ReturnModel<Map<String, Object>>(result);
				model.setHeader(new ReturnHeader(HttpStatus.INTERNAL_SERVER_ERROR.value(), "Invalid token", false));
				return model;
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			result.put("exception", ex.getClass().getSimpleName());
			result.put("message", ex.getMessage());
			ReturnModel<Map<String, Object>> model = new ReturnModel<Map<String, Object>>(result);
			model.setHeader(new ReturnHeader(HttpStatus.INTERNAL_SERVER_ERROR.value(), ex.getMessage(), false));
			return model;
		}
		ReturnModel<Map<String, Object>> model = new ReturnModel<Map<String, Object>>(result);
		model.setHeader(new ReturnHeader(HttpStatus.OK.value(), "", true));
		return model;
	}
}
