package com.nhnst.oc.sso.model;

import java.io.Serializable;

import org.apache.commons.lang3.StringUtils;
import org.springframework.http.HttpStatus;

public class ReturnHeader implements Serializable {

	private static final long serialVersionUID = 9035966860739454762L;
	
	private Integer resultCode;
	
	private String resultMessage;
	
	private Boolean isSuccessful;
	
	public ReturnHeader(Boolean isSuccessful) {
		this.resultCode = HttpStatus.OK.value();
		this.resultMessage = StringUtils.EMPTY;
		this.isSuccessful = isSuccessful;
	}
	
	public ReturnHeader(Integer resultCode, String resultMessage, Boolean isSuccessful) {
		this.resultCode = resultCode;
		this.resultMessage = resultMessage;
		this.isSuccessful = isSuccessful;
	}

	public Integer getResultCode() {
		return resultCode;
	}

	public void setResultCode(Integer resultCode) {
		this.resultCode = resultCode;
	}

	public String getResultMessage() {
		return resultMessage;
	}

	public void setResultMessage(String resultMessage) {
		this.resultMessage = resultMessage;
	}

	public Boolean getIsSuccessful() {
		return isSuccessful;
	}

	public void setIsSuccessful(Boolean isSuccessful) {
		this.isSuccessful = isSuccessful;
	}

}
